static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xC9, 0x0D, 0xF8, 0xC5, 0xD6, 0xD8, 0x9D, 0x64, 0x3C, 0x36,
        0x88, 0x13, 0xCC, 0xB6, 0xB6, 0xAD, 0xBF, 0x1C, 0x27, 0x70,
        0x61, 0x0E, 0x76, 0x26, 0x35, 0x6C, 0x4B, 0xFD, 0xF9, 0x78,
        0x7A, 0xD7, 0x9E, 0x59, 0xFD, 0xD3, 0x35, 0x07, 0x57, 0xA0,
        0xB1, 0x2A, 0x2A, 0x1D, 0x28, 0x92, 0x68, 0xB7, 0x49, 0x33,
        0x9A, 0x45, 0x25, 0xA9, 0x0E, 0x0F, 0x32, 0xC7, 0x0E, 0x11,
        0x6B, 0xCB, 0xBF, 0x9B
    };
    static unsigned char dhg_512[] = {
        0x02
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
